% Estimate Stage 4
%clear all
load dataS4
load bootflag
load uhflag

bootflag 
uhflag 

load table1bdata
ma = [mean(ozvec) mean(xrace) mean(crvec)];

uniqueinc = unique(ainc);
for i = 1:3
    meanpr(i) = paramhatS2(4) + paramhatS2(5)*(uniqueinc(i)-1);
end
meanprminc = meanpr(2);

inccon = find(.45*(ainc-1)>u10); 
wealthcon = find((awealth-1)>.1*20*u10);
iwcon = intersect(inccon,wealthcon);

if uhflag == 1

if bootflag == 0
nbn = 1;
bb=1;
end

if bb == 1
dwtpM1 = zeros(nbn,3); dwtpM2 = zeros(nbn,3);  dwtpM3 = zeros(nbn,3);  dwtpM4 = zeros(nbn,3);  dwtpM5 = zeros(nbn,4); 
dwtpS1 = zeros(nbn,3); dwtpS2 = zeros(nbn,3); dwtpS3 = zeros(nbn,3);
swtpS1 = zeros(nbn,3); swtpS2 = zeros(nbn,3); swtpS3 = zeros(nbn,3);
betaM1c = zeros(nbn,3); betaM2c = zeros(nbn,3); betaM3c = zeros(nbn,3); betaM4c = zeros(nbn,3);
MCres = zeros(nbn,5); hetres = zeros(nbn,4); ptransparam = zeros(nbn,8);
end
if bb >1
    load resS4uh1b hetres MCres betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...   
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    ptransparam 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Regressions separate by income
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% inc == 5  ($40,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 5); index = intersect(index,iwcon);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS1 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS1(bb,1) = .1*ma(1)*betaS1(2)/meanpr(1)*10000; 
dwtpS1(bb,2)=.1*ma(2)*betaS1(3)/meanpr(1)*10000;
dwtpS1(bb,3)=.1*ma(3)*betaS1(4)/meanpr(1)*10000;

% inc == 13 ($120,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 13); index = intersect(index,iwcon);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS2 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS2(bb,1) = .1*ma(1)*betaS2(2)/meanpr(2)*10000; 
dwtpS2(bb,2)=.1*ma(2)*betaS2(3)/meanpr(2)*10000;
dwtpS2(bb,3)=.1*ma(3)*betaS2(4)/meanpr(2)*10000;

% inc ==  21 ($200,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 21); index = intersect(index,iwcon);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS3 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS3(bb,1) = .1*ma(1)*betaS3(2)/meanpr(3)*10000; 
dwtpS3(bb,2)=.1*ma(2)*betaS3(3)/meanpr(3)*10000;
dwtpS3(bb,3)=.1*ma(3)*betaS3(4)/meanpr(3)*10000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MCres(bb,:) = paramhatS2;

alpha = [alpha11 + alpha12]; gamma = [gamma11; gamma12];
utransparam = [prctile(alpha',25)' prctile(alpha',50)' prctile(alpha',75)'];
ptransparam(bb,:) = gamma';

hetres(bb,:) = [phip; temppie; ]';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if bootflag == 0
save resS4uh1 MCres  betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...    
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    utransparam ptransparam hetres

elseif bootflag == 1
save resS4uh1b MCres betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...   
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    bb ptransparam hetres
end

end
 