function f = contract_J1(evshiftsmall,share,evalueold,piem, J,numtype, typej)
% Adapted from code by Aviv Nevo

tol = 1e-14;
flag = 1;

norm = 1;
avgnorm = 1;

i = 0;
while norm > tol*10^(flag*floor(i/200)) && avgnorm > 1e-3*tol*10^(flag*floor(i/200))
	evalue = evalueold.*share./modelshare_J1(evalueold,evshiftsmall,piem,J,numtype, typej);      
    t = abs(log(evalue./evalueold));
	norm = max(t);
    avgnorm = sum(t)/(J+1);
  	evalueold = evalue;
    i = i + 1;
end
% Make mean equal zero
evalue = evalue./exp(mean(log(evalue)));

f = log(evalue);


if i >200
disp(['# of iterations for delta convergence:  ' num2str(i)])
[norm avgnorm]
[m tt]
end

