function slike = lo_like_s2logit_nohet(b,y,x,fvar)

t = size(x,1);
i = ones(t,1);

exba = fvar.*(exp(x*b));
emxba = 1./exba;
    
cdf = i./(i+emxba);

tmp = find(cdf <=0);
[n1 n2] = size(tmp);
if n1 ~= 0; cdf(tmp) = 0.00001; end;

tmp = find(cdf >= 1);
[n1 n2] = size(tmp);
if n1 ~= 0; cdf(tmp) = 0.99999; end;

like = y.*log(cdf)+(i-y).*log(i-cdf);
slike = sum(like);





