% Prep data for first stage estimation
%clear all
load S1data

load uhflag
load bootflag

global evaluetildeold

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if uhflag == 0

paramstartS2_nohet = [-9.5;0.02;0.1;-0.2;0.006];
valuetildeMa = valuefunc_J1_inv_nohet(share,Ma,J,T);

tempbtt = [];
for h = 1:numtype
tempbtt = [tempbtt;valuetildeMa];
end
valuetildeMSa = tempbtt;     

evaluetildeMSa = exp(valuetildeMSa);
esumvalue = squeeze(sum(evaluetildeMSa,2)) ;

evis2 = evaluetildeMSa(indevs2(:,1)); evim2 = esumvalue(indevm2(:,1)); 
evis3 = evaluetildeMSa(indevs3(:,1)); evim3 = esumvalue(indevm3(:,1)); 
evis4 = evaluetildeMSa(indevs4(:,1)); evim4 = esumvalue(indevm4(:,1)); 
evis5 = evaluetildeMSa(indevs5(:,1)); evim5 = esumvalue(indevm5(:,1)); 
evis6 = evaluetildeMSa(indevs6(:,1)); evim6 = esumvalue(indevm6(:,1)); 
evis7 = evaluetildeMSa(indevs7(:,1)); evim7 = esumvalue(indevm7(:,1)); 
evis8 = evaluetildeMSa(indevs8(:,1)); evim8 = esumvalue(indevm8(:,1)); 
evis9 = evaluetildeMSa(indevs9(:,1)); evim9 = esumvalue(indevm9(:,1)); 
evis10 = evaluetildeMSa(indevs10(:,1)); evim10 = esumvalue(indevm10(:,1)); 
evis11 = evaluetildeMSa(indevs11(:,1)); evim11 = esumvalue(indevm11(:,1)); 

efvar_sx = [evim2./evis2; evim3./evis3; evim4./evis4; evim5./evis5; evim6./evis6;...
    evim7./evis7; evim8./evis8; evim9./evis9; evim10./evis10; evim11./evis11];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

S2res = s2logit_nohet(y_sx,x_sx,efvar_sx,paramstartS2_nohet);
paramhatS2 = S2res.beta;
fvalg_log = S2res.lik;
iter = S2res.iter; 
     
    phi=0;
    phiMa =  phi*ones(Ma,1);
    ephiMa = exp(phiMa);
    phiMSa = repmat(phiMa,[numtype J+1 T]);
    piep = zeros(numtype-1,1);
end

if uhflag == 1
    
evaluetildeold = ones(Ma,J+1,T);

% matlab 2013
matlabpool size
if ans > 0    
matlabpool close
end
matlabpool(2)

% % matlab 2014
% isempty(gcp('nocreate'))
% if ans > 0    
% delete(gcp('nocreate'))
% end
% parpool(2)

pie1=zeros(1,numtype);
for h= 1:numtype;
pie1(h) = mean(typei==h);
end
pie1 = [log(pie1(:,1)./pie1(:,3)) log(pie1(:,2)./pie1(:,3))];
piep = pie1';

phip = [1.5];

paramstart = [1.8; -0.1;-0.6; -9.5;0.02;0.15;-0.4;0.01];

options = optimset('MaxFunEvals', 100000, 'MaxIter',500  );
[paramhat, fval,exitflag,output,grad] = fminunc('likelihood_con_p',paramstart,options,numtype, J, nobs, T, indic, S2vecindex,...
    valuetildeindex, denomindex, nll, dec_sx, y_sx, x_sx, ...
    indevs2, indevs3, indevs4, indevs5, indevs6, indevs7, indevs8, indevs9, indevs10, indevs11,...
    indevm2, indevm3, indevm4, indevm5, indevm6, indevm7, indevm8, indevm9, indevm10, indevm11,...
    indevo2, indevo3, indevo4, indevo5, indevo6, indevo7, indevo8, indevo9, indevo10, indevo11,...
    share,Ma,typej);

phip = paramhat(1); 
piep = paramhat(2:numtype);
paramhatS2 = paramhat(numtype+ 1:end);

temppie = zeros(numtype-1,1);
for h = 1:numtype-1
temppie(h) = exp(piep(h))./(1+sum(exp(piep)));
end
temppie = [temppie; 1-sum(temppie)];
pieMa = ones(Ma,1)*temppie';

phiMa =  phip*ones(Ma,1);
ephiMa = exp(phiMa);

valuetildeMa     = valuefunc_J1(ephiMa,share,evaluetildeold,pieMa,Ma,T,J,numtype,typej);

tempbtt = [];
for h = 1:numtype
tempbtt = [tempbtt;valuetildeMa];
end

phiMSa = repmat(phiMa,[numtype J+1 T]);
valuetildeMSa = tempbtt + indic.*phiMSa;

% matlab 2013
matlabpool close

% % matlab 2014
% delete(gcp('nocreate'))
end

clearvars all * -except Ztype Zvalsa Zvalsb income...
  K b2 bb Ma Mb MSa MSb J T neigh totapp incvals nhoodallr ztractallr zyearallr priceallr10 maxw minw maxi mini id1 idall id2...
   valuetildeMa valuetildeMSa gamma paramhatS2  pie indexb phi phiMa phiMSa numtype sqft band uhflag mininshare lambda numtype...
   indic phiMSa piep pieMa phip temppie countyj neigh_county_map xyear xtract xrace polldata crimedata paramhat temppie fval exitflag output grad...

save resS2

