% Estimate utility decomposition
%clear all
load dataS4
load bootflag
load uhflag

load table1bdata
ma = [mean(ozvec) mean(xrace) mean(crvec)];

uniqueinc = unique(ainc);
for i = 1:3
    meanpr(i) = paramhatS2(4) + paramhatS2(5)*(uniqueinc(i)-1);
end
meanprminc = meanpr(2);

if uhflag == 1

if bootflag == 0
nbn = 1;
bb=1;
end

if bb == 1
dwtpM1 = zeros(nbn,3); dwtpM2 = zeros(nbn,3);  dwtpM3 = zeros(nbn,3);  dwtpM4 = zeros(nbn,3);  dwtpM5 = zeros(nbn,4); 
dwtpS1 = zeros(nbn,3); dwtpS2 = zeros(nbn,3); dwtpS3 = zeros(nbn,3);
swtpS1 = zeros(nbn,3); swtpS2 = zeros(nbn,3); swtpS3 = zeros(nbn,3);
betaM1c = zeros(nbn,3); betaM2c = zeros(nbn,3); betaM3c = zeros(nbn,3); betaM4c = zeros(nbn,3);
MCres = zeros(nbn,5); hetres = zeros(nbn,4); ptransparam = zeros(nbn,8);
end
if bb >1
    load resS4uh1b hetres MCres betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...   
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    ptransparam 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Dynamic Regressions with all data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% reg 1
index = find(awealth <= 23 & awealth >= 3);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2)  incduma  yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaM1(bb,:) = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpM1(bb,1) = .1*ma(1)*betaM1(bb,2)/meanprminc*10000; 
dwtpM1(bb,2) =.1*ma(2)*betaM1(bb,3)/meanprminc*10000;
dwtpM1(bb,3) =.1*ma(3)*betaM1(bb,4)/meanprminc*10000;
betaM1c(bb,1) = betaM1(bb,2); betaM1c(bb,2) = betaM1(bb,3); betaM1c(bb,3) = betaM1(bb,4);

% reg 2
betaM2(bb,:) = regress(lhs_dynamic(index),X(index,:));
dwtpM2(bb,1) = .1*ma(1)*betaM2(bb,2)/meanprminc*10000; 
dwtpM2(bb,2)=.1*ma(2)*betaM2(bb,3)/meanprminc*10000;
dwtpM2(bb,3)=.1*ma(3)*betaM2(bb,4)/meanprminc*10000;
betaM2c(bb,1) = betaM2(bb,2); betaM2c(bb,2) = betaM2(bb,3); betaM2c(bb,3) = betaM2(bb,4);
 
% reg 3
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma  incduma  yearduma stateduma typematchdum]; 
betaM3(bb,:) = rq_fnm(X, lhs_dynamic, .5);
dwtpM3(bb,1) = .1*ma(1)*betaM3(bb,2)/meanprminc*10000; 
dwtpM3(bb,2)=.1*ma(2)*betaM3(bb,3)/meanprminc*10000;
dwtpM3(bb,3)=.1*ma(3)*betaM3(bb,4)/meanprminc*10000;
betaM3c(bb,1) = betaM3(bb,2); betaM3c(bb,2) = betaM3(bb,3); betaM3c(bb,3) = betaM3(bb,4);

% reg 4
betaM4(bb,:) = regress(lhs_dynamic,X);
dwtpM4(bb,1) = .1*ma(1)*betaM4(bb,2)/meanprminc*10000; 
dwtpM4(bb,2)=.1*ma(2)*betaM4(bb,3)/meanprminc*10000;
dwtpM4(bb,3)=.1*ma(3)*betaM4(bb,4)/meanprminc*10000;
betaM4c(bb,1) = betaM4(bb,2); betaM4c(bb,2) = betaM4(bb,3); betaM4c(bb,3) = betaM4(bb,4);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Regressions separate by income
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% inc == 5  ($40,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 5);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS1 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS1(bb,1) = .1*ma(1)*betaS1(2)/meanpr(1)*10000; 
dwtpS1(bb,2)=.1*ma(2)*betaS1(3)/meanpr(1)*10000;
dwtpS1(bb,3)=.1*ma(3)*betaS1(4)/meanpr(1)*10000;

alphaS1 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS1(bb,1) = .1*ma(1)*alphaS1(2)/meanpr(1)*10000; 
swtpS1(bb,2)=.1*ma(2)*alphaS1(3)/meanpr(1)*10000;
swtpS1(bb,3)=.1*ma(3)*alphaS1(4)/meanpr(1)*10000;

% inc == 13 ($120,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 13);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS2 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS2(bb,1) = .1*ma(1)*betaS2(2)/meanpr(2)*10000; 
dwtpS2(bb,2)=.1*ma(2)*betaS2(3)/meanpr(2)*10000;
dwtpS2(bb,3)=.1*ma(3)*betaS2(4)/meanpr(2)*10000;

alphaS2 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS2(bb,1) = .1*ma(1)*alphaS2(2)/meanpr(2)*10000; 
swtpS2(bb,2)=.1*ma(2)*alphaS2(3)/meanpr(2)*10000;
swtpS2(bb,3)=.1*ma(3)*alphaS2(4)/meanpr(2)*10000;

% inc ==  21 ($200,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 21);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma typematchdum]; % Z = [oz,race,crime];
betaS3 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS3(bb,1) = .1*ma(1)*betaS3(2)/meanpr(3)*10000; 
dwtpS3(bb,2)=.1*ma(2)*betaS3(3)/meanpr(3)*10000;
dwtpS3(bb,3)=.1*ma(3)*betaS3(4)/meanpr(3)*10000;

alphaS3 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS3(bb,1) = .1*ma(1)*alphaS3(2)/meanpr(3)*10000; 
swtpS3(bb,2)=.1*ma(2)*alphaS3(3)/meanpr(3)*10000;
swtpS3(bb,3)=.1*ma(3)*alphaS3(4)/meanpr(3)*10000;

MCres(bb,:) = paramhatS2;

alpha = [alpha11 + alpha12]; gamma = [gamma11; gamma12];
utransparam = [prctile(alpha',25)' prctile(alpha',50)' prctile(alpha',75)'];
ptransparam(bb,:) = gamma';

hetres(bb,:) = [phip; temppie; ]';


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if bootflag == 0
save resS4uh1 MCres  betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...    
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    utransparam ptransparam hetres
[phip; temppie; ]'
phip/meanpr(2)*10000

elseif bootflag == 1
save resS4uh1b MCres betaM1c betaM2c betaM3c betaM4c ...
    dwtpM1 dwtpM2  dwtpM3  dwtpM4...   
    dwtpS1 dwtpS2 dwtpS3 swtpS1 swtpS2 swtpS3...
    bb ptransparam hetres
end

elseif uhflag == 0 

if bootflag == 0
nbn = 1;
bb=1;
end

if bb == 1
dwtpS1uh0 = zeros(nbn,3); dwtpS2uh0 = zeros(nbn,3); dwtpS3uh0 = zeros(nbn,3);
swtpS1uh0 = zeros(nbn,3); swtpS2uh0 = zeros(nbn,3); swtpS3uh0 = zeros(nbn,3);
end
if bb >1
    load resS4uh0b  ...
    dwtpS1uh0 dwtpS2uh0 dwtpS3uh0 swtpS1uh0 swtpS2uh0 swtpS3uh0  
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Regressions separate by income
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% inc == 5  ($40,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 5);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma ]; % Z = [oz,race,crime];
betaS1 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS1uh0(bb,1) = .1*ma(1)*betaS1(2)/meanpr(1)*10000; 
dwtpS1uh0(bb,2)=.1*ma(2)*betaS1(3)/meanpr(1)*10000;
dwtpS1uh0(bb,3)=.1*ma(3)*betaS1(4)/meanpr(1)*10000;

alphaS1 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS1uh0(bb,1) = .1*ma(1)*alphaS1(2)/meanpr(1)*10000; 
swtpS1uh0(bb,2)=.1*ma(2)*alphaS1(3)/meanpr(1)*10000;
swtpS1uh0(bb,3)=.1*ma(3)*alphaS1(4)/meanpr(1)*10000;

% inc == 13 ($120,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 13);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma ]; % Z = [oz,race,crime];
betaS2 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS2uh0(bb,1) = .1*ma(1)*betaS2(2)/meanpr(2)*10000; 
dwtpS2uh0(bb,2)=.1*ma(2)*betaS2(3)/meanpr(2)*10000;
dwtpS2uh0(bb,3)=.1*ma(3)*betaS2(4)/meanpr(2)*10000;

alphaS2 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS2uh0(bb,1) = .1*ma(1)*alphaS2(2)/meanpr(2)*10000; 
swtpS2uh0(bb,2)=.1*ma(2)*alphaS2(3)/meanpr(2)*10000;
swtpS2uh0(bb,3)=.1*ma(3)*alphaS2(4)/meanpr(2)*10000;

% inc ==  21 ($200,000)
index = find(awealth <= 23 & awealth >= 3 & ainc == 21);
X = [ones(size(lhs_dynamic)) Z countyduma wealthduma(:,3:end-2) yearduma stateduma ]; % Z = [oz,race,crime];
betaS3 = rq_fnm(X(index,:), lhs_dynamic(index), .5);
dwtpS3uh0(bb,1) = .1*ma(1)*betaS3(2)/meanpr(3)*10000; 
dwtpS3uh0(bb,2)=.1*ma(2)*betaS3(3)/meanpr(3)*10000;
dwtpS3uh0(bb,3)=.1*ma(3)*betaS3(4)/meanpr(3)*10000;

alphaS3 = rq_fnm(X(index,:), lhs_static(index), .5);
swtpS3uh0(bb,1) = .1*ma(1)*alphaS3(2)/meanpr(3)*10000; 
swtpS3uh0(bb,2)=.1*ma(2)*alphaS3(3)/meanpr(3)*10000;
swtpS3uh0(bb,3)=.1*ma(3)*alphaS3(4)/meanpr(3)*10000;


if bootflag == 0
save resS4uh0 ...
    dwtpS1uh0 dwtpS2uh0 dwtpS3uh0 swtpS1uh0 swtpS2uh0 swtpS3uh0

elseif bootflag == 1
save resS4uh0b  ...
    dwtpS1uh0 dwtpS2uh0 dwtpS3uh0 swtpS1uh0 swtpS2uh0 swtpS3uh0  bb
end


end