% prep data for utility decomposition
%clear all
load resS3

minc = mean(income);

for i=1:J
    countyt(i,1)=neigh_county_map(find(neigh(i)==neigh_county_map(:,1)),2);
 end

utilMSbvec = zeros(J*T,MSb);valueMSbvec = zeros(J*T,MSb);ozdaysvec=[];countyvec=[];ozvec=[];crvec=[];rvec=[];meanpricevec=[];
usercost = .05*meanpricecs;
for m= 1:MSb
    temp =[];temp1=[];temp2=[]; temp3=[];
    for j=1:J
       temp = [temp; squeeze(utilMSb(m,j,1:T))];
       temp1 = [temp1; squeeze(valueMSb(m,j,1:T))];
        if(m==1)
        countyvec=[countyvec;countyt(j)*ones(T,1)];
        meanpricevec = [meanpricevec;meanpricecs(j,1:T)'];
        ozvec=[ozvec;ozdays(j,:)'];
        crvec=[crvec;crimedays(j,:)'];
        end
    end
   utilMSbvec(:,m) = temp;
   valueMSbvec(:,m) = temp1;
end

usercost = .05*meanpricecs(:,1:T);
for m= 1:MSb
    temp2 =[];
    for j=1:J
        temp2 = [temp2; usercost(j,:)'];
    end
    usercostvec(:,m) = temp2;
end

usercost10 = .05*quinpricecs10(:,1:T);
for m= 1:MSb
    temp2 =[];
    for j=1:J
        temp2 = [temp2; usercost10(j,:)'];
    end
    usercostvec10(:,m) = temp2;
end

tr = kron([1:1:J]',ones(T,1)); 
yr=[];
for i= 1:J
    yr = [yr; [1:1:T]'];
end

temp = kron(-gammafmctau, ones(1,J*T))';
utilMSbveca = utilMSbvec - temp.*usercostvec;
staticutilMSbveca = (1-beta)*valueMSbvec - temp.*usercostvec;

save table1bdata xrace crvec ozvec  meanpricevec  

Z=[];lhs_static=[];lhs_dynamic=[]; user=[]; 
u10 = [];
for m=1:MSb
    index = find(utilMSbvec(:,m)~=0);
    d=[ozvec,xrace,crvec,countyvec,yr];
    Z = [Z;d(index,:)]; 
    lhs_static=[lhs_static;staticutilMSbveca(index,m)];
    lhs_dynamic=[lhs_dynamic;utilMSbveca(index,m)];
    user = [user;usercostvec(index,m)];
    u10 = [u10;usercostvec10(index,m)];
end

awealth=kron(ZvalsbS(:,1)+1,ones(J*(T-1),1));
ainc=kron(ZvalsbS(:,2)+1,ones(J*(T-1),1));
astate=kron(ZvalsbS(:,3),ones(J*(T-1),1)); 
atype = kron([1:1:MSb]',ones(J*(T-1),1));

Z=[Z,awealth,ainc,atype];

county=Z(:,4);

ageog = 1*[county == 41 | county == 75 | county == 81] + 2*[county == 85]  + 3*[county == 1 | county == 13] ;
typematchdum = [astate == ageog];

%get counties and inc in units so can use dummyvar command
t2cty=unique(county);
for i=1:length(t2cty)
    county(county==t2cty(i))=i;
end
inc=ainc;
t2cty=unique(inc);
for i=1:length(t2cty)
    inc(inc==t2cty(i))=i;
end

year = Z(:,5) -1;
Z = Z(:,1:3);

wealthdum = dummyvar(awealth);  wealthduma = wealthdum(:,2:end);
incdum = dummyvar(inc);  incduma = incdum(:,2:end);
countydum = dummyvar(county);  countyduma = countydum(:,2:end);
yeardum = dummyvar(year);  yearduma = yeardum(:,2:end);
statedum = dummyvar(astate); stateduma = statedum(:,2:end);

clearvars all * -except usercostvec Z lhs_*  paramhatS2 sqft lotsize ...
     wealthduma incduma countyduma yearduma awealth ainc astate stateduma year minc utilMSbvec valueMSbvec...
     bd taubd alphatau paramhatS2 S2coeffs outcoeffs phi bb alpha11 alpha12 gamma11 gamma12...
     county typematchdum phip temppie user  u10  

save dataS4


