function f = disdraws(ndraws,empdist)
% get draws from empirical distribution
% use modification of John Kennan approximation to a continuous distribution 

draws = zeros(ndraws,1);
for i = 1:ndraws
    temp = (2*i -1)/(2*ndraws);
    draws(i) =  prctile(empdist,100*temp);
end
f = draws;
