% cd to correct directory
clear all

bootflag = 0;
save bootflag bootflag

uhflag = 1;
save uhflag uhflag
% Read in the data
datareadstm
% Prep data for combined household location and mobility decision estimation
S12prep
% Estimate combined household location and mobility decisions
S12est
% Prep data for transition probability estimation
S3prep
% Estimate transition probabilities
S3est
% Prep data for utility decomposition 
S4prep
% Estimate utility decomposition
S4est
%S4est_liqcon %uncomment to run  final regressions with liquidity constraints

% get amenity time series properties 
Appendix_regs
% get measure of fit
fit
% get evidence of forward-looking behavior
dynamicevidence_shares
% calculate number of moves are within sub-regions
region_to_region_moves

uhflag = 0;
save uhflag uhflag
S12est
S3prep
S3est
S4prep
S4est

% get measure of fit
fit


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nbn =40;
numnodes =6;

rand('state',111222);
fullseeds=randsample(1000000,nbn*numnodes,false);

cd ../boot1
seeds = fullseeds( (1-1)*nbn + 1:(1-1)*nbn + nbn);
save seeds seeds
cd ../

cd boot2
seeds = fullseeds( (2-1)*nbn + 1:(2-1)*nbn + nbn);
save seeds seeds
cd ../

cd boot3
seeds = fullseeds( (3-1)*nbn + 1:(3-1)*nbn + nbn);
save seeds seeds
cd ../

cd boot4
seeds = fullseeds( (4-1)*nbn + 1:(4-1)*nbn + nbn);
save seeds seeds
cd ../

cd boot5
seeds = fullseeds( (5-1)*nbn + 1:(5-1)*nbn + nbn);
save seeds seeds
cd ../

cd boot6
seeds = fullseeds( (6-1)*nbn + 1:(6-1)*nbn + nbn);
save seeds seeds
cd ../Est_Files


% The following can be manually run simultaneously for greater speed 
cd ../boot1
master_boot
cd ../
cd ../boot2
master_boot
cd ../
cd ../boot3
master_boot
cd ../
cd ../boot4
master_boot
cd ../
cd ../boot5
master_boot
cd ../
cd ../boot6
master_boot
cd ../Est_Files

bootcollect
results_tables_b






